---
title: Compilation - Behind the Stage
date: 2021-05-13T08:33:48+05:30
weight: 4
slug: compilation
mermaid: true
chapter: Introduction
expertise: Beginner
---

When you hit that build button in your IDE or run `gcc` on your code, you wonder what all goes behind the scene. In this chapter we will discuss about what happens during compilation of C program, from source code to executable.

Understanding compilation process helps you become better programmer and good at debugging. The below flow chart shows different steps and file types involved in generating a executable file from a source file.

{{<img alt="comilation-process" src="/images/c-programming/compilation-process.png" cap="Compilation Process" width="943" height="1003">}}

## Files

### Source and header files (.c & .h)

These are the file that a programmer writes in C. Generally with .c or .h extension. These files along with code will also contains comments which help in understanding the code. These comments are only for understanding purpose, they don't end up in the final executable.

### Assembly files (.asm or .s)

The assembly file contains the assembly instructions and ends with .asm or .s extension. These files could be added along with source files to project. When a source file is compiled, it will also generate assembly intermediate file. `--asm` option to `gcc` will create assembly file with extension `.s`.

### Object files (.o)

...

### Libraries files (.lib & .a)

...

### Linker scripts (.lkr)

...

### Executable (.bin, .img & .exe)

...

## Compiler

The compiler is responsible syntax checking, removing comments and converting the code to assembly language code. This is achieved by 3 different components/phases of compilation.

### Pre-processor

The pre-processor will eliminate all human readable sections of source code.

- Removes all comments and white-spaces.
- Replaces all macros with actual values.
- Includes required header files in to source files.
- Eliminates parts of the code based on build environment (Conditional compilation).

### Parser

The Parser performs the bulk of the work in the compiler.

- **Lexical Analysis**: Creates tokens from code provided by the preprocessor. (Tokens are characters or a string of characters that together form something significant, such as a keyword, mathematical operator, or variable name.)
- **Syntactical Analysis**: Makes sure that the tokens form expressions that conform to the rules of C.
- **Semantic Analysis**: Determines what actions must be taken by each expression and pass a list of these actions to the code generator.

### Code Generator

The code generator does the actual conversion of actions fed by Parser to their equivalent platform-specific assembly code (.asm). The code generator is unique to each micro-controller or micro-processor. The generated assembly code is relocatable, it is not assigned the physical memory yet.

## Assembler

The assembler converts the code from assembly language to machine language (binary format) which are object files (.obj). The code generated by assembler are specific to the platform against to which it is compiling. Each statement in .asm file is replaced by its machine specific operation.

## Librarian or Archiver

The archiver will group generated object files into a library. Libraries can be static (.1) or dynamic (.lib). These libraries can be reused in other projects.

## Linker

Linking is the final step of compilation process. Post linking we will have a executable file that could be .hex, .img or .exe file based on the configuration. Linker will figure out based on the linker script file (.lkr) what part of the code is placed at which memory location. It also defines the boundaries for each memory region. Linker will map every instruction, variable and function to a physical memory location. By now we will have a code which can run on our target.

Linker based on the configuration will generate debug file which is useful for debugging purpose. The debug file in addition to executable will facilitate the communication between host and target.

Linker will also generate a map file which has information about physical address mapping of variables and functions. This file is helpful for debugging a target running executable without debug info.

> In order to automate the process of compilation there are different tools available like `make` & `c-make`.

## Target

This is where your code runs. It could be the machine that you built your code on or other device that your code built for.
